#ifndef _IMGBBOX_H
#define _IMGBBOX_H

#include "IMGPrerequisites.h"


namespace IMG {

#define BOUNDINGBOX_MAXVALUE 1000000000.
#define BOX_CORNER_xyz 0
#define BOX_CORNER_xyZ 1
#define BOX_CORNER_xYz 2
#define BOX_CORNER_xYZ 3
#define BOX_CORNER_Xyz 4
#define BOX_CORNER_XyZ 5
#define BOX_CORNER_XYz 6
#define BOX_CORNER_XYZ 7

#define BOX_CORNER_xy 0
#define BOX_CORNER_xY 2
#define BOX_CORNER_Xy 4
#define BOX_CORNER_XY 6

//*
//	this class encaplusalte the ogre::AxisAlignedBox
//*
class _IMGExport BBox: public Ogre::AxisAlignedBox {
  public:
    BBox();

	~BBox();

    void initialize();

	Ogre::Vector3 getMinimum();

	Ogre::Vector3 getMaximum();

    void addBoundingVector3(float x, float y, float z);

    void print();

	Ogre::Vector3 getCorner(int corner) const;

    bool intersects(Ogre::Vector3 v);

};

}
#endif
